CHARACTER_FACING_INCREMENT = 2;
CHARACTER_ROTATION_CONSTANT = 0.6
CHARACTER_SELECT_ROTATION_START_X = nil;

CHARACTERSELECT_REGION_SELECTED = nil;
CHARACTERSELECT_RECOVER_DELETE = nil;
MAX_REGION_BUTTONS = 15;
MAX_CHARACTERS_DISPLAYED = 8;
MAX_CHARACTERS_PER_REALM = 10;

CHARACTER_SELECT = {};

LOADLISTCOLOR = {};
LOADLISTCOLOR[1] = { r = 0, g = 1, b = 0 };
LOADLISTCOLOR[2] = { r = 1, g = 1, b = 1 };
LOADLISTCOLOR[3] = { r = 0.94, g = 0.4, b = 0.13 };
LOADLISTCOLOR[4] = { r = 1, g = 0, b = 0 };
checkPoint = false;
numberOfChars = 8;

function CharacterSelect_OnLoad(this)
	CHARACTER_SELECT.createIndex = 0;
	CHARACTER_SELECT.selectedIndex = 0;
	CHARACTER_SELECT.SelectedButton = nil;
	CHARACTER_SELECT.selectLast = 0;
	CHARACTER_SELECT.currentModel = "";
	this:RegisterEvent("UPDATE_CHARACTER_SELECT_LIST");
	this:RegisterEvent("UPDATE_CHARACTER_PARALLEZONE");
	this:RegisterEvent("UPDATE_SELECTED_CHARACTER");
	
	fastLoginLoggedIn=false;

end

function CharacterSelect_OnShow(this)
	AccountLogin:Hide();
	if ( not fastLoginNoZoom ) then
		OpenCharacterSelect();
	end	
	CharacterList_Update();
	RegionList_Update();
	CharacterSelectRealmName:SetText(GetCurrentRealm());
end

function CharacterSelect_OnHide(this)
	CloseCharacterSelect();
	if (not fastLoginRelogin) then
		if (fastLoginChrSel < numberOfChars) then
			fastLoginChrSel = fastLoginChrSel + 1;
		else
			fastLoginLoggedIn=true;
		end
	end
	checkPoint = true;
end

function CharacterSelect_OnMouseDown(this)
	CHARACTER_SELECT_ROTATION_START_X = GetCursorPos();
end

function CharacterSelect_OnMouseUp(this)
	CHARACTER_SELECT_ROTATION_START_X = nil;
end

local time_remaining = fastLoginReloginWaitTime;

function CharacterSelect_OnUpdate(this, elapsedTime)
	if ( CHARACTER_SELECT_ROTATION_START_X ) then
		local x = GetCursorPos();
		local diff = (x - CHARACTER_SELECT_ROTATION_START_X) * CHARACTER_ROTATION_CONSTANT;
		CHARACTER_SELECT_ROTATION_START_X = x;
		SetCharacterSelectFacing(GetCharacterSelectFacing() - diff);
	end
	
	if (fastLoginRelogin and checkPoint) then
		time_remaining = time_remaining - elapsedTime;
		if (time_remaining > 0) then
			return
		end
	end
	
	time_remaining = fastLoginReloginWaitTime;
	if ( fastLoginAutoEnter and ( not fastLoginLoggedIn ) ) then
		CHARACTERSELECT_REGION_SELECTED = fastLoginRegSel;
		CharacterSelect_EnterWorld();
	else
		CharacterSelect_Exit();
	end
end

function CharacterSelect_OnMouseWheel(this, delta)
	LoginScrollBar_OnMouseWheel(CharacterSelectListScrollBar, delta);
end

function CharacterSelect_OnKeyDown(this, arg1)
	if ( arg1 == "ESCAPE" ) then
		AccountLogin_Exit();
	elseif ( arg1 == "ENTER" ) then
		CharacterSelect_EnterWorld();
	end
end

function CharacterSelectEnterWorldButton_Update()
	if ( GetNumCharacters() > 0 and CHARACTERSELECT_REGION_SELECTED ~= nil ) then
		numberOfChars = GetNumCharacters();
		CharacterSelectEnterWorldButton:Enable();
	else
		CharacterSelectEnterWorldButton:Disable();
	end
end

function CharacterList_Update()
	local maxNums = GetNumCharacters() - MAX_CHARACTERS_DISPLAYED;
	if ( maxNums > 0 ) then
		CharacterSelectListScrollBar:SetMinMaxValues(0, maxNums);
		CharacterSelectListScrollBar:Show();
	else
		CharacterSelectListScrollBar:SetMinMaxValues(0, 0);
		CharacterSelectListScrollBar:Hide();
	end

	UpdateCharacterList();
end

function UpdateCharacterList()
	local numChars = GetNumCharacters();
	local index = CharacterSelectListScrollBar:GetValue() + 1;
	local coords, button;
	local name, gender, mainLevel, mainClass, secLevel, secClass, zone, destroyTime;

	for i = 1, MAX_CHARACTERS_DISPLAYED do
		button = getglobal("CharacterSelectCharacterButton"..i);
		if ( index <= numChars ) then
			name, gender, mainLevel, mainClass, secLevel, secClass, zone, destroyTime = GetCharacterInfo(index);

			if ( gender == 0 ) then
				gender = "MALE";
			else
				gender = "FEMALE";
			end
		
			if ( not name ) then
				button:SetText("ERROR!!");
			else
				local infoText;
				if ( not zone ) then
					zone = "";
				end
			
				if ( secLevel > 0 ) then
					infoText = mainClass.." Lv "..mainLevel.." / "..secClass.." Lv "..secLevel;
				else
					infoText = mainClass.." Lv "..mainLevel;
				end
			
				getglobal("CharacterSelectCharacterButton"..i.."ButtonTextName"):SetText(name);
				getglobal("CharacterSelectCharacterButton"..i.."ButtonTextInfo"):SetText(infoText);
			end
			button.zone = zone;
			button.destroyTime = destroyTime;
			button.index = index;
			
			button:SetAlpha(1);
			if ( destroyTime ) then
				button:SetAlpha(0.5);
			end
			
			button:Show();
			index = index + 1;
		else
			button:Hide();
		end
	end

	if ( numChars == 0 ) then
		CharacterSelectDeleteButton:Disable();
	else
		CharacterSelectDeleteButton:Enable();
	end
	CharacterSelectEnterWorldButton_Update();

	if ( numChars < MAX_CHARACTERS_DISPLAYED ) then
		CHARACTER_SELECT.createIndex = index;
		CharacterSelectCreateButton:SetID(index);
		CharacterSelectCreateButton:Show();
	else
		CHARACTER_SELECT.createIndex = 0;
		CharacterSelectCreateButton:Hide();
	end
	
	if ( numChars == 0 ) then
		CHARACTER_SELECT.selectedIndex = 0;
		return;
	end

	CHARACTER_SELECT.selectedIndex = fastLoginChrSel;
	CharacterSelectListScrollBar:SetValue(0);

	CharacterSelect_SelectCharacter(CHARACTER_SELECT.selectedIndex, 1);
end

function CharacterSelect_OnEvent(this, event)
	if ( event == "UPDATE_CHARACTER_SELECT_LIST" ) then		
		CharacterList_Update();
		UpdateCharacterSelection();
	elseif ( event == "UPDATE_SELECTED_CHARACTER" ) then
		if ( arg1 > 0 ) then
			CHARACTER_SELECT.selectedIndex = arg1;
		end
		UpdateCharacterSelection();
	elseif ( event == "UPDATE_CHARACTER_PARALLEZONE" ) then
		CHARACTERSELECT_REGION_SELECTED = arg1;
		RegionListUpdate();
	end
end

function UpdateCharacterSelection()
	CHARACTERSELECT_RECOVER_DELETE = nil;
	CharacterSelectEnterWorldButton:SetText(TEXT("CHARACTER_ENTER_WORLD"));	
	
	local button;
	for i = 1, MAX_CHARACTERS_DISPLAYED do
		button = getglobal("CharacterSelectCharacterButton"..i);
		if ( button.index == CHARACTER_SELECT.selectedIndex ) then
			CharacterSelectZoneName:SetText(button.zone);
			button:LockHighlight();
			
			if ( (button ~= nil) and (button.destroyTime ~= nil) ) then
				CHARACTERSELECT_RECOVER_DELETE = 1;
				CharacterSelectEnterWorldButton:SetText(TEXT("CHARACTER_SELECT_RECOVER_DELETE"));
			end
		else
			button:UnlockHighlight();
		end
	end
end

function CharacterSelect_EnterWorld()
	if ( CHARACTERSELECT_RECOVER_DELETE ) then
		LoginDialog_Show("RECOVER_DELETE_CHARACTER");
	else
		EnterWorld(CHARACTERSELECT_REGION_SELECTED);		
	end
end

function CharacterSelect_Exit()
	DisconnectFromServer();
	fastLoginLoggedIn = false;
	SetLoginScreen("login");
end

function CharacterSelectButton_OnClick(this)
	local index = this.index;
	PlaySoundByPath("sound\\interface\\ui_charselect_pick.mp3");
	if ( index ~= CHARACTER_SELECT.selectedIndex ) then
		if (fastLoginRelogin) then
			fastLoginChrSel = index;
		end
		CharacterSelect_SelectCharacter(index);
	end
	CharacterSelectEnterWorldButton_Update();
end

function CharacterSelectButton_OnUpdate(this, elapsedTime)
	if ( this.destroyTime ) then
		this.destroyTime = this.destroyTime - elapsedTime;
	end
end

function CharacterSelectButton_OnEnter(this)
	local seconds = this.destroyTime;
	if ( seconds ) then
		LoginTooltip:ClearAllAnchors();
		LoginTooltip:SetAnchor("TOPRIGHT", "BOTTOMLEFT", this, 0, 0);
		if ( seconds >= 3600 ) then
			LoginTooltip:SetText(string.format("%d"..LOGIN_HOURS, math.ceil(seconds / 3600)));
		else
			LoginTooltip:SetText(string.format("%d"..LOGIN_MINUTES, math.ceil(seconds / 60)));
		end
	else
		LoginTooltip:Hide();
	end
end

function CharacterSelect_AccountOptions()
end

function CharacterSelect_TechSupport()
end

function CharacterSelect_Delete()
	if ( CHARACTER_SELECT.selectedIndex > 0 ) then
		LoginDialog_Show("DELETE_CHARACTER");
	end
end

function CharacterSelect_RecoverDelete()
	RecoverDeleteCharacter(CHARACTER_SELECT.selectedIndex);
end

function CharacterSelect_SelectCharacter(id, noCreate)
	if ( id == CHARACTER_SELECT.createIndex ) then
		if ( not noCreate ) then
			SetLoginScreen("charcreate");
		end
	else
		SelectCharacter(id);
	end
end

function CharacterSelectRotateRightButton_OnUpdate(this, elapsed)
	if ( this:IsButtonPushed("LeftButton") ) then
		SetCharacterSelectFacing(GetCharacterSelectFacing() - CHARACTER_FACING_INCREMENT);
	end
end

function CharacterSelectRotateLeftButton_OnUpdate(this, elapsed)
	if ( this:IsButtonPushed("LeftButton") ) then
		SetCharacterSelectFacing(GetCharacterSelectFacing() + CHARACTER_FACING_INCREMENT);
	end
end

function RegionListButton_OnClick(this)
 	CHARACTERSELECT_REGION_SELECTED = this.index;
	RegionListUpdate();
end

function RegionList_Update()
	local maxNums = GetNumParalleZones() - MAX_REGION_BUTTONS;
	if ( maxNums > 0 ) then
		RegionListScrollBar:SetMinMaxValues(0, maxNums);
		RegionListScrollBar:Show();
	else
		RegionListScrollBar:SetMinMaxValues(0, 0);
		RegionListScrollBar:Hide();
	end

	RegionListUpdate();
end

function RegionListUpdate()
	local numRegions = GetNumParalleZones();
	local index = RegionListScrollBar:GetValue() + 1;
	local button, nameText, loadText;
	local name, load, color;
	
	for i = 1, MAX_REGION_BUTTONS do
		button = getglobal("RegionListButton"..i);
		nameText = getglobal("RegionListButton"..i.."Name");
		loadText = getglobal("RegionListButton"..i.."Load");
		if ( index <= numRegions ) then
			name, load = GetParalleZonesInfo(index);
			nameText:SetText(name);
			nameText:SetColor(LOADLISTCOLOR[load].r, LOADLISTCOLOR[load].g, LOADLISTCOLOR[load].b);
			loadText:SetText(TEXT("LOAD_TYPE"..load));
			loadText:SetColor(LOADLISTCOLOR[load].r, LOADLISTCOLOR[load].g, LOADLISTCOLOR[load].b);

			button.index = index;
			button:Show();			
			if ( index == CHARACTERSELECT_REGION_SELECTED ) then
				button:LockHighlight();
			else
				button:UnlockHighlight();
			end
		else
			button:Hide();
		end
		index = index + 1;
	end
	CharacterSelectEnterWorldButton_Update();
end

